<?php

namespace Drupal\vipps_mobilepay_commerce\Resolver;

/**
 * Runs the added resolvers one by one until one of them returns the reference.
 *
 * Each resolver in the chain can be another chain, which is why this interface
 * extends the reference resolver one.
 */
interface ChainReferenceResolverInterface extends ReferenceResolverInterface {

  /**
   * Adds a resolver.
   *
   * @param \Drupal\vipps_mobilepay_commerce\Resolver\ReferenceResolverInterface $resolver
   *   The resolver.
   */
  public function addResolver(ReferenceResolverInterface $resolver);

  /**
   * Gets all added resolvers.
   *
   * @return \Drupal\vipps_mobilepay_commerce\Resolver\ReferenceResolverInterface[]
   *   The resolvers.
   */
  public function getResolvers();

}
