<?php

namespace Drupal\vipps_mobilepay_commerce\Resolver;

use Drupal\commerce_payment\Entity\PaymentInterface;

/**
 * Defines the interface for reference resolvers.
 */
interface ReferenceResolverInterface {

  /**
   * Resolves the remote reference.
   *
   * @param \Drupal\commerce_payment\Entity\PaymentInterface $payment
   *   Payment entity. Note that payment hasn't been saved at that time hence
   *   it doesn't have an ID. Please consider entity immutable and do not save.
   *
   * @return string|null
   *   Resolved remote reference.
   */
  public function resolve(PaymentInterface $payment): ?string;

}
